- Main Page
- Classes
- Files
- Directories
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# TiXmlDocument Class Reference

Always the top level node. More...

`#include <tinyxml.h>`

Inheritance diagram for TiXmlDocument:

List of all members.

## Public Member Functions
| TiXmlDocument ()
| Create an empty document, that has no name.
| TiXmlDocument (const char *documentName)
| Create a document with a name. The name of the document is also the filename of the xml.
bool | LoadFile (TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Load a file using the current document value.
bool | SaveFile () const
| Save a file using the current document value. Returns true if successful.
bool | LoadFile (const char *filename, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Load a file using the given filename. Returns true if successful.
bool | SaveFile (const char *filename) const
| Save a file using the given filename. Returns true if successful.
bool | LoadFile (FILE *, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Load a file using the given FILE*.
bool | SaveFile (FILE *) const
| Save a file using the given FILE*. Returns true if successful.
virtual const char * | Parse (const char *p, TiXmlParsingData *data=0, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Parse the given null terminated block of xml data.
const TiXmlElement * | RootElement () const
| Get the root element -- the only top level element -- of the document.
bool | Error () const
| If an error occurs, Error will be set to true.
const char * | ErrorDesc () const
| Contains a textual (english) description of the error if one occurs.
int | ErrorId () const
| Generally, you probably want the error string ( ErrorDesc() ).
int | ErrorRow ()
| Returns the location (if known) of the error.
int | ErrorCol ()
| The column where the error occured. See ErrorRow().
void | SetTabSize (int _tabsize)
| SetTabSize() allows the error reporting functions (ErrorRow() and ErrorCol()) to report the correct values for row and column.
void | ClearError ()
| If you have handled the error, it can be reset with this call.
void | Print () const
| Write the document to standard out using formatted printing ("pretty print").
char * | PrintToMemory () const
| Write the document to a string using formatted printing ("pretty print").
virtual void | Print (FILE *cfile, int depth=0, TIXML_STRING *str=0) const
| Print this Document to a FILE stream.
virtual const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null not of the requested type.
virtual TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null not of the requested type.
virtual bool | Accept (TiXmlVisitor *content, int depth=0) const
| Walk the XML tree visiting this node and all of its children.
## Protected Member Functions
virtual TiXmlNode * | Clone () const
| Create an exact duplicate of this node and return it.

## Detailed Description

Always the top level node.

A document binds together all the XML pieces. It can be saved, loaded, and printed to the screen. The 'value' of a document node is the xml file name.

## Member Function Documentation

void TiXmlDocument::ClearError | ( |  | ) | `[inline]`

If you have handled the error, it can be reset with this call.

The error state is automatically cleared if you Parse a new XML block.

virtual TiXmlNode* TiXmlDocument::Clone | ( |  | ) | const`[protected, virtual]`

Create an exact duplicate of this node and return it.

The memory must be deleted by the caller.

Implements TiXmlNode.

bool TiXmlDocument::Error | ( |  | ) | const`[inline]`

If an error occurs, Error will be set to true.

Also,

- The ErrorId() will contain the integer identifier of the error (not generally useful)
- The ErrorDesc() method will return the name of the error. (very useful)
- The ErrorRow() and ErrorCol() will return the location of the error (if known)

int TiXmlDocument::ErrorId | ( |  | ) | const`[inline]`

Generally, you probably want the error string ( ErrorDesc() ).

But if you prefer the ErrorId, this function will fetch it.

int TiXmlDocument::ErrorRow | ( |  | ) | `[inline]`

Returns the location (if known) of the error.

The first column is column 1, and the first row is row 1. A value of 0 means the row and column wasn't applicable (memory errors, for example, have no row/column) or the parser lost the error. (An error in the error reporting, in that case.)

See also:
  SetTabSize, Row, Column

bool TiXmlDocument::LoadFile | ( | FILE * | ,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` |
| ) |  |  |

Load a file using the given FILE*.

Returns true if successful. Note that this method doesn't stream - the entire object pointed at by the FILE* will be interpreted as an XML file. TinyXML doesn't stream in XML from the current file location. Streaming may be added in the future.

bool TiXmlDocument::LoadFile | ( | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` | ) |

Load a file using the current document value.

Returns true if successful. Will delete any existing document data before loading.

virtual const char* TiXmlDocument::Parse | ( | const char * | p,
|  | TiXmlParsingData * | data = `0`,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` |
| ) |  |  | `[virtual]`

Parse the given null terminated block of xml data.

Passing in an encoding to this method (either TIXML_ENCODING_LEGACY or TIXML_ENCODING_UTF8 will force TinyXml to use that encoding, regardless of what TinyXml might otherwise try to detect.

Implements TiXmlBase.

char* TiXmlDocument::PrintToMemory | ( |  | ) | const

Write the document to a string using formatted printing ("pretty print").

This will allocate a character array (new char[]) and return it as a pointer. The calling code pust call delete[] on the return char* to avoid a memory leak.

const TiXmlElement* TiXmlDocument::RootElement | ( |  | ) | const`[inline]`

Get the root element -- the only top level element -- of the document.

In well formed XML, there should only be one. TinyXml is tolerant of multiple elements at the document level.

void TiXmlDocument::SetTabSize | ( | int | _tabsize | ) | `[inline]`

SetTabSize() allows the error reporting functions (ErrorRow() and ErrorCol()) to report the correct values for row and column.

It does not change the output or input in any way.

By calling this method, with a tab size greater than 0, the row and column of each node and attribute is stored when the file is loaded. Very useful for tracking the DOM back in to the source file.

The tab size is required for calculating the location of nodes. If not set, the default of 4 is used. The tabsize is set per document. Setting the tabsize to 0 disables row/column tracking.

Note that row and column tracking is not supported when using operator>>.

The tab size needs to be enabled before the parse or load. Correct usage:

    		TiXmlDocument doc;
    		doc.SetTabSize( 8 );
    		doc.Load( "myfile.xml" );

See also:
  Row, Column

The documentation for this class was generated from the following file:

- tinyxml.h